<script lang="ts">
import { Component, Prop } from 'vue-property-decorator';
import type { Pixel, Unit } from '@/data';
import { PixelUnitWithSeconds } from '@/data';
import type { SyncLabel } from '@/synchronization-logic/SynchronizationActions';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import type { CanvasMouseEvent } from '../LabelBehavior.vue';
import LabelBehavior from '../LabelBehavior.vue';

/**
 * Creates a new sync point on dblclick
 */
@Component
export default class BCreateSyncOnDblClick extends LabelBehavior {
  @Prop({ required: true })
  pixelUnit!: Unit<Pixel>;

  @Prop({ required: false })
  actions!: SynchronizationActions;

  mounted() {
    this.register('staff-dblclick', this.createSync);
  }

  createSync(event: CanvasMouseEvent) {
    let created: SyncLabel;

    // If currently on a waveform of the track being editing, convert directly from event pixel
    if (PixelUnitWithSeconds.isUnitWithSeconds(this.pixelUnit)) {
      // Get the timestamp from the pixel
      const timestamp = this.pixelUnit.fromPixelToSecond(event.x);
      // Create a new sync point
      created = this.actions.createSyncPointFromSecond(timestamp);
    } else {
      // Convert to musical time
      const onset = this.pixelUnit.toOnset(event.x).value;
      // Snap to closest note
      const snappedOnset = this.pixelUnit.snapOnset(onset);
      // Create a new sync point
      created = this.actions.createSyncPointFromOnset(snappedOnset);
    }
    this.actions.select(created.id, true);
  }
}

</script>
